<template>
    <div class="w-full flex flex-col relative">
        <div class="flex flex-col m-2 bg-gray-200 p-2 w-full">
            <div class="w-full bg-white">
                <table class="relative table-auto w-full">
                    <thead>
                        <tr class="border-b border-gray-200">
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Name</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Role</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Rank</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Assigner</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Actions</th>
                        </tr>
                    </thead>
                    <tbody class="bg-white overflow-y-auto w-full">
                        <tr v-for="p in privileges" :key="p.seq">
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{p.resource.name}}</div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                 <v-select label="name" :options="roles" :reduce="a => a.id" v-model="p.role" class="w-full"></v-select>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <v-select label="name" :options="ranks" :reduce="a => a.id" v-model="p.rank" class="w-full"></v-select>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full"><a :href="p.assigner.profile">{{p.assigner.first}} {{p.assigner.last}}</a></div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <button v-if="p.role != p.prerole || p.rank != p.prerank" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="save(p)">
                                    <img svg-inline src="./pix/zond/save-disk.svg" class="w-4 h-4 fill-current" />
                                </button>
                                <button v-if="p.role != p.prerole || p.rank != p.prerank" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="undo(p)">
                                    <img svg-inline src="./pix/zond/refresh.svg" class="w-4 h-4 fill-current" />
                                </button>
                                <button v-if="p.permission > 0" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="remove(p)">
                                    <img svg-inline src="./pix/zond/trash.svg" class="w-4 h-4 fill-current" />
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <wee-modal ref="mutation" :timeout="2000">
            <template v-slot:loading="e">
                <img src="./pix/infinity-transparent.png" class="block relative m-auto" />
                <div class="text-white w-full text-center">
                    Saving permission for resource {{e.data.name}}
                </div>
            </template>
            <template v-slot:success="e">
                <div class="block relative m-auto">
                    <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                </div>
                <div class="text-white w-full text-center">
                    Successfully created permission {{e.data.id}}
                </div>
            </template>
            <template v-slot:failure="e">
                <div class="block relative m-auto">
                    <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                </div>
                <div class="text-white w-full text-center">
                    Failed to save permission for resource {{e.data.name}} because
                    <div class="text-pink-200">{{e.data.message}}</div>
                </div>
            </template>
        </wee-modal>
        <wee-modal ref="deletion" :timeout="2000">
            <template v-slot:loading="e">
                <img src="./pix/infinity-transparent.png" class="block relative m-auto" />
                <div class="text-white w-full text-center">
                    Deleting permission for resource {{e.data.name}}
                </div>
            </template>
            <template v-slot:success="e">
                <div class="block relative m-auto">
                    <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                </div>
                <div class="text-white w-full text-center">
                    Successfully deleted permission {{e.data.id}}
                </div>
            </template>
            <template v-slot:failure="e">
                <div class="block relative m-auto">
                    <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                </div>
                <div class="text-white w-full text-center">
                    Failed to save permission for resource {{e.data.name}} because
                    <div class="text-pink-200">{{e.data.message}}</div>
                </div>
            </template>
        </wee-modal>
    </div>
</template>
<script>
import Vue from 'vue'
import axios from 'axios'
import WeeModal from './WeeModal'
import vSelect from 'vue-select'
import 'vue-select/dist/vue-select.css';

Vue.component('v-select', vSelect);

export default {
    name: "WeeSpatialProjectPrivilegeEditor",
    props: ["project"],
    data(){
        return {
            selected: null,
            privileges: [],
            roles: [],
            ranks: []
        };
    },
    components: {
        WeeModal
    },
    created(){
        this.load();
    },
    methods: {
        load(){
            let self = this;
            axios.get(this.privilegesUrl).then(function(response){
                self.privileges = response.data.privileges.map(function(p){
                    p.prerole = p.role;
                    p.prerank = p.rank;
                    p.assigner.profile = '/user/profile/'+p.assigner.id;
                    return p;
                });
                self.roles      = response.data.roles;
                self.ranks      = response.data.ranks;
            }).catch(function(error){
                console.log(error);
            });
        },
        reload(){
            this.load();
        },
        select(result){
            this.selected = result;
            this.clear();
        },
        clear(){
            this.$refs.search.clear();
        },
        undo(p){
            p.role = p.prerole;
            p.rank = p.prerank;
        },
        remove(p){
            let self = this;
            this.$refs.deletion.activate({
                name: p.resource.name
            });
            axios.post(this.removeUrl+p.permission, {}).then(function(response){
                if(response.data.success){
                    self.$refs.deletion.done({
                        id: response.data.id
                    });
                    p.permission = 0;
                    for(const i in self.privileges){
                        const privilege = self.privileges[i];
                        if(privilege.seq == p.seq){
                            Vue.set(self.privileges, i, p);
                            break;
                        }
                    }
                    self.undo(p);
                    self.reload();
                    self.$emit('removed');
                }else{
                    self.$refs.deletion.failed({
                        name: p.resource.name,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.deletion.failed({
                    name: p.resource.name,
                    message: error
                });
            });
        },
        save(p){
            let self = this;
            this.$refs.mutation.activate({
                name: p.resource.name
            });
            axios.post(this.saveUrl+p.permission, {
                resource: p.resource.id,
                role:     p.role,
                rank:     p.rank
            }).then(function(response){
                if(response.data.success){
                    self.$refs.mutation.done({
                        id: response.data.id
                    });
                    p.permission = response.data.id;
                    for(const i in self.privileges){
                        const privilege = self.privileges[i];
                        if(privilege.seq == p.seq){
                            Vue.set(self.privileges, i, p);
                            break;
                        }
                    }
                    self.undo(p);
                    self.reload();
                    self.$emit('saved');
                }else{
                    self.$refs.mutation.failed({
                        name: p.resource.name,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.mutation.failed({
                    name: p.resource.name,
                    message: error
                });
            });
        }
    },
    computed: {
        privilegesUrl(){
            return '/privileges/'+this.project+'/fetch';
        },
        saveUrl(){
            return '/privileges/'+this.project+'/permit/';
        },
        removeUrl(){
            return '/privileges/'+this.project+'/revoke/';
        }
    }
}
</script>
<style>

</style>
